dojo.provide("dojo.logging.Logger");
dojo.provide("dojo.log");
dojo.require("dojo.lang");
dojo.logging.Record=function(_1,_2){
this.level=_1;
this.message=_2;
this.time=new Date();
};
dojo.logging.LogFilter=function(_3){
this.passChain=_3||"";
this.filter=function(_4){
return true;
};
};
dojo.logging.Logger=function(){
this.cutOffLevel=0;
this.propagate=true;
this.parent=null;
this.data=[];
this.filters=[];
this.handlers=[];
};
dojo.lang.extend(dojo.logging.Logger,{argsToArr:function(_5){
var _6=[];
for(var x=0;x<_5.length;x++){
_6.push(_5[x]);
}
return _6;
},setLevel:function(_8){
this.cutOffLevel=parseInt(_8);
},isEnabledFor:function(_9){
return parseInt(_9)>=this.cutOffLevel;
},getEffectiveLevel:function(){
if((this.cutOffLevel==0)&&(this.parent)){
return this.parent.getEffectiveLevel();
}
return this.cutOffLevel;
},addFilter:function(_a){
this.filters.push(_a);
return this.filters.length-1;
},removeFilterByIndex:function(_b){
if(this.filters[_b]){
delete this.filters[_b];
return true;
}
return false;
},removeFilter:function(_c){
for(var x=0;x<this.filters.length;x++){
if(this.filters[x]===_c){
delete this.filters[x];
return true;
}
}
return false;
},removeAllFilters:function(){
this.filters=[];
},filter:function(_e){
for(var x=0;x<this.filters.length;x++){
if((this.filters[x]["filter"])&&(!this.filters[x].filter(_e))||(_e.level<this.cutOffLevel)){
return false;
}
}
return true;
},addHandler:function(_10){
this.handlers.push(_10);
return this.handlers.length-1;
},handle:function(rec){
if((!this.filter(rec))||(rec.level<this.cutOffLevel)){
return false;
}
for(var x=0;x<this.handlers.length;x++){
if(this.handlers[x]["handle"]){
this.handlers[x].handle(rec);
}
}
return true;
},log:function(lvl,msg){
if((this.propagate)&&(this.parent)&&(this.parent.rec.level>=this.cutOffLevel)){
this.parent.log(lvl,msg);
return false;
}
this.handle(new dojo.logging.Record(lvl,msg));
return true;
},debug:function(msg){
return this.logType("DEBUG",this.argsToArr(arguments));
},info:function(msg){
return this.logType("INFO",this.argsToArr(arguments));
},warning:function(msg){
return this.logType("WARNING",this.argsToArr(arguments));
},error:function(msg){
return this.logType("ERROR",this.argsToArr(arguments));
},critical:function(msg){
return this.logType("CRITICAL",this.argsToArr(arguments));
},exception:function(msg,e,_1c){
if(e){
var _1d=[e.name,(e.description||e.message)];
if(e.fileName){
_1d.push(e.fileName);
_1d.push("line "+e.lineNumber);
}
msg+=" "+_1d.join(" : ");
}
this.logType("ERROR",msg);
if(!_1c){
throw e;
}
},logType:function(_1e,_1f){
var na=[dojo.logging.log.getLevel(_1e)];
if(typeof _1f=="array"){
na=na.concat(_1f);
}else{
if((typeof _1f=="object")&&(_1f["length"])){
na=na.concat(this.argsToArr(_1f));
}else{
na=na.concat(this.argsToArr(arguments).slice(1));
}
}
return this.log.apply(this,na);
}});
void (function(){
var _21=dojo.logging.Logger.prototype;
_21.warn=_21.warning;
_21.err=_21.error;
_21.crit=_21.critical;
})();
dojo.logging.LogHandler=function(_22){
this.cutOffLevel=(_22)?_22:0;
this.formatter=null;
this.data=[];
this.filters=[];
};
dojo.logging.LogHandler.prototype.setFormatter=function(_23){
dj_unimplemented("setFormatter");
};
dojo.logging.LogHandler.prototype.flush=function(){
dj_unimplemented("flush");
};
dojo.logging.LogHandler.prototype.close=function(){
dj_unimplemented("close");
};
dojo.logging.LogHandler.prototype.handleError=function(){
dj_unimplemented("handleError");
};
dojo.logging.LogHandler.prototype.handle=function(_24){
if((this.filter(_24))&&(_24.level>=this.cutOffLevel)){
this.emit(_24);
}
};
dojo.logging.LogHandler.prototype.emit=function(_25){
dj_unimplemented("emit");
};
void (function(){
var _26=["setLevel","addFilter","removeFilterByIndex","removeFilter","removeAllFilters","filter"];
var tgt=dojo.logging.LogHandler.prototype;
var src=dojo.logging.Logger.prototype;
for(var x=0;x<_26.length;x++){
tgt[_26[x]]=src[_26[x]];
}
})();
dojo.logging.log=new dojo.logging.Logger();
dojo.logging.log.levels=[{"name":"DEBUG","level":1},{"name":"INFO","level":2},{"name":"WARNING","level":3},{"name":"ERROR","level":4},{"name":"CRITICAL","level":5}];
dojo.logging.log.loggers={};
dojo.logging.log.getLogger=function(_2a){
if(!this.loggers[_2a]){
this.loggers[_2a]=new dojo.logging.Logger();
this.loggers[_2a].parent=this;
}
return this.loggers[_2a];
};
dojo.logging.log.getLevelName=function(lvl){
for(var x=0;x<this.levels.length;x++){
if(this.levels[x].level==lvl){
return this.levels[x].name;
}
}
return null;
};
dojo.logging.log.addLevelName=function(_2d,lvl){
if(this.getLevelName(_2d)){
this.err("could not add log level "+_2d+" because a level with that name already exists");
return false;
}
this.levels.append({"name":_2d,"level":parseInt(lvl)});
return true;
};
dojo.logging.log.getLevel=function(_2f){
for(var x=0;x<this.levels.length;x++){
if(this.levels[x].name.toUpperCase()==_2f.toUpperCase()){
return this.levels[x].level;
}
}
return null;
};
dojo.logging.MemoryLogHandler=function(_31,_32,_33,_34){
dojo.logging.LogHandler.call(this,_31);
this.numRecords=(typeof djConfig["loggingNumRecords"]!="undefined")?djConfig["loggingNumRecords"]:((_32)?_32:-1);
this.postType=(typeof djConfig["loggingPostType"]!="undefined")?djConfig["loggingPostType"]:(_33||-1);
this.postInterval=(typeof djConfig["loggingPostInterval"]!="undefined")?djConfig["loggingPostInterval"]:(_33||-1);
};
dojo.logging.MemoryLogHandler.prototype=new dojo.logging.LogHandler();
dojo.logging.MemoryLogHandler.prototype.emit=function(_35){
this.data.push(_35);
if(this.numRecords!=-1){
while(this.data.length>this.numRecords){
this.data.shift();
}
}
};
dojo.logging.logQueueHandler=new dojo.logging.MemoryLogHandler(0,50,0,10000);
dojo.logging.logQueueHandler.emit=function(_36){
var _37=String(dojo.log.getLevelName(_36.level)+": "+_36.time.toLocaleTimeString())+": "+_36.message;
if(!dj_undef("debug",dj_global)){
dojo.debug(_37);
}else{
if((typeof dj_global["print"]=="function")&&(!dojo.render.html.capable)){
print(_37);
}
}
this.data.push(_36);
if(this.numRecords!=-1){
while(this.data.length>this.numRecords){
this.data.shift();
}
}
};
dojo.logging.log.addHandler(dojo.logging.logQueueHandler);
dojo.log=dojo.logging.log;

