dojo.provide("dojo.math.matrix");
dojo.math.matrix.iDF=0;
dojo.math.matrix.multiply=function(a,b){
a=dojo.math.matrix.copy(a);
b=dojo.math.matrix.copy(b);
var ax=a[0].length;
var ay=a.length;
var bx=b[0].length;
var by=b.length;
if(ax!=by){
dojo.debug("Can't multiply matricies of sizes "+ax+","+ay+" and "+bx+","+by);
return [[0]];
}
var c=[];
for(var k=0;k<ay;k++){
c[k]=[];
for(var i=0;i<bx;i++){
c[k][i]=0;
for(var m=0;m<ax;m++){
c[k][i]+=a[k][m]*b[m][i];
}
}
}
return c;
};
dojo.math.matrix.inverse=function(a){
a=dojo.math.matrix.copy(a);
var _c=a.length;
var m=dojo.math.matrix.create(_c,_c);
var mm=dojo.math.matrix.adjoint(a);
var _f=dojo.math.matrix.determinant(a);
var dd=0;
if(_f==0){
dojo.debug("Determinant Equals 0, Not Invertible.");
return [[0]];
}else{
dd=1/_f;
}
for(var i=0;i<_c;i++){
for(var j=0;j<_c;j++){
m[i][j]=dd*mm[i][j];
}
}
return m;
};
dojo.math.matrix.determinant=function(a){
a=dojo.math.matrix.copy(a);
if(a.length!=a[0].length){
dojo.debug("Can't calculate the determiant of a non-squre matrix!");
return 0;
}
var tms=a.length;
var det=1;
var b=dojo.math.matrix.upperTriangle(a);
for(var i=0;i<tms;i++){
det*=b[i][i];
}
det=det*dojo.math.matrix.iDF;
return det;
};
dojo.math.matrix.upperTriangle=function(m){
m=dojo.math.matrix.copy(m);
var f1=0;
var _1a=0;
var tms=m.length;
var v=1;
dojo.math.matrix.iDF=1;
for(var col=0;col<tms-1;col++){
for(var row=col+1;row<tms;row++){
v=1;
var _1f=0;
while((m[col][col]==0)&&!_1f){
if(col+v>=tms){
dojo.math.matrix.iDF=0;
_1f=1;
}else{
for(var c=0;c<tms;c++){
_1a=m[col][c];
m[col][c]=m[col+v][c];
m[col+v][c]=_1a;
}
v++;
dojo.math.matrix.iDF*=-1;
}
}
if(m[col][col]!=0){
f1=(-1)*m[row][col]/m[col][col];
for(var i=col;i<tms;i++){
m[row][i]=f1*m[col][i]+m[row][i];
}
}
}
}
return m;
};
dojo.math.matrix.create=function(a,b){
var m=[];
for(var i=0;i<b;i++){
m[i]=[];
for(var j=0;j<a;j++){
m[i][j]=0;
}
}
return m;
};
dojo.math.matrix.adjoint=function(a){
a=dojo.math.matrix.copy(a);
var tms=a.length;
if(a.length!=a[0].length){
dojo.debug("Can't find the adjoint of a non-square matrix");
return [[0]];
}
if(tms==1){
dojo.debug("Can't find the adjoint of a 1x1 matrix");
return [[0]];
}
var m=dojo.math.matrix.create(tms,tms);
var ii=0;
var jj=0;
var ia=0;
var ja=0;
var det=0;
for(var i=0;i<tms;i++){
for(var j=0;j<tms;j++){
ia=0;
ja=0;
var ap=dojo.math.matrix.create(tms-1,tms-1);
for(ii=0;ii<tms;ii++){
for(jj=0;jj<tms;jj++){
if((ii!=i)&&(jj!=j)){
ap[ia][ja]=a[ii][jj];
ja++;
}
}
if((ii!=i)&&(jj!=j)){
ia++;
}
ja=0;
}
det=dojo.math.matrix.determinant(ap);
m[i][j]=Math.pow(-1,(i+j))*det;
}
}
m=dojo.math.matrix.transpose(m);
return m;
};
dojo.math.matrix.transpose=function(a){
a=dojo.math.matrix.copy(a);
var m=dojo.math.matrix.create(a.length,a[0].length);
for(var i=0;i<a.length;i++){
for(var j=0;j<a[i].length;j++){
m[j][i]=a[i][j];
}
}
return m;
};
dojo.math.matrix.format=function(a){
function format_int(x){
var dp=5;
var fac=Math.pow(10,dp);
var a=Math.round(x*fac)/fac;
var b=a.toString();
if(b.charAt(0)!="-"){
b=" "+b;
}
var _3c=0;
for(var i=1;i<b.length;i++){
if(b.charAt(i)=="."){
_3c=1;
}
}
if(!_3c){
b+=".";
}
while(b.length<dp+3){
b+="0";
}
return b;
}
var ya=a.length;
var xa=a[0].length;
var _40="";
for(var y=0;y<ya;y++){
_40+="| ";
for(var x=0;x<xa;x++){
_40+=format_int(a[y][x])+" ";
}
_40+="|\n";
}
return _40;
};
dojo.math.matrix.copy=function(a){
var ya=a.length;
var xa=a[0].length;
var m=dojo.math.matrix.create(xa,ya);
for(var y=0;y<ya;y++){
for(var x=0;x<xa;x++){
m[y][x]=a[y][x];
}
}
return m;
};
dojo.math.matrix.scale=function(k,a){
a=dojo.math.matrix.copy(a);
var ya=a.length;
var xa=a[0].length;
for(var y=0;y<ya;y++){
for(var x=0;x<xa;x++){
a[y][x]*=k;
}
}
return a;
};

