dojo.provide("dojo.widget.Chart");
dojo.provide("dojo.widget.Chart.DataSeries");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.Widget");
dojo.require("dojo.graphics.color");
dojo.widget.tags.addParseTreeHandler("dojo:chart");
dojo.requireAfterIf(dojo.render.svg.support.builtin,"dojo.widget.svg.Chart");
dojo.widget.Chart=function(){
dojo.widget.Widget.call(this);
this.widgetType="Chart";
this.isContainer=false;
this.series=[];
this.assignColors=function(){
var _1=30,sat=120,lum=120;
var _2=Math.round(330/this.series.length);
for(var i=0;i<this.series.length;i++){
var c=dojo.graphics.color.hsl2rgb(_1,sat,lum);
if(!this.series[i].color){
this.series[i].color=dojo.graphics.color.rgb2hex(c[0],c[1],c[2]);
}
_1+=_2;
}
};
};
dojo.inherits(dojo.widget.Chart,dojo.widget.Widget);
dojo.widget.Chart.DataSeries=function(_5,_6,_7,_8){
this.id="DataSeries"+dojo.widget.Chart.DataSeries.count++;
this.key=_5;
this.label=_6||this.id;
this.plotType=_7||0;
this.color=_8;
this.values=[];
};
dojo.widget.Chart.DataSeries.prototype={add:function(v){
if(v.x==null||v.value==null){
dojo.raise("dojo.widget.Chart.DataSeries.add: v must have both an 'x' and 'value' property.");
}
this.values.push(v);
},clear:function(){
this.values=[];
},createRange:function(_a){
var _b=this.values.length-1;
var _c=_a||this.values.length;
return {index:_b,length:_c,start:Math.max(_b-_c,0)};
},getMean:function(_d){
var _e=this.createRange(_d);
if(_e.index<0){
return 0;
}
var t=0,c=0;
for(var i=_e.index;i>=_e.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t+=n;
c++;
}
}
t/=Math.max(c,1);
return t;
},getMovingAverage:function(len){
var _13=this.createRange(len);
if(_13.index<0){
return 0;
}
var t=0,c=0;
for(var i=_13.index;i>=_13.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t+=n;
c++;
}
}
t/=Math.max(c,1);
return t;
},getVariance:function(len){
var _18=this.createRange(len);
if(_18.index<0){
return 0;
}
var t=0,s=0,c=0;
for(var i=_18.index;i>=_18.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t+=n;
s+=Math.pow(n,2);
c++;
}
}
return (s/c)-Math.pow(t/c,2);
},getStandardDeviation:function(len){
return Math.sqrt(this.getVariance(len));
},getMax:function(len){
var _1e=this.createRange(len);
if(_1e.index<0){
return 0;
}
var t=0;
for(var i=_1e.index;i>=_1e.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t=Math.max(n,t);
}
}
return t;
},getMin:function(len){
var _23=this.createRange(len);
if(_23.index<0){
return 0;
}
var t=0;
for(var i=_23.index;i>=_23.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t=Math.min(n,t);
}
}
return t;
},getMedian:function(len){
var _28=this.createRange(len);
if(_28.index<0){
return 0;
}
var a=[];
for(var i=_28.index;i>=_28.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
var b=false;
for(var j=0;j<a.length&&!b;j++){
if(n==a[j]){
b=true;
}
}
if(!b){
a.push(n);
}
}
}
a.sort();
if(a.length>0){
return a[Math.ceil(a.length/2)];
}
return 0;
},getMode:function(len){
var _2f=this.createRange(len);
if(_2f.index<0){
return 0;
}
var o={},ret=0,m=0;
for(var i=_2f.index;i>=_2f.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
if(!o[this.values[i].value]){
o[this.values[i].value]=1;
}else{
o[this.values[i].value]++;
}
}
}
for(var p in o){
if(m<o[p]){
m=o[p];
ret=p;
}
}
return parseFloat(ret);
}};

