dojo.provide("dojo.widget.Editor");
dojo.provide("dojo.widget.html.Editor");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.Toolbar");
dojo.require("dojo.widget.RichText");
dojo.require("dojo.widget.ColorPalette");
dojo.widget.tags.addParseTreeHandler("dojo:Editor");
dojo.widget.html.Editor=function(){
dojo.widget.HtmlWidget.call(this);
this.contentFilters=[];
};
dojo.inherits(dojo.widget.html.Editor,dojo.widget.HtmlWidget);
dojo.widget.html.Editor.itemGroups={textGroup:["bold","italic","underline","strikethrough"],blockGroup:["formatBlock","fontName"],justifyGroup:["justifyleft","justifycenter","justifyright"],commandGroup:["save","cancel"],colorGroup:["forecolor","hilitecolor"],listGroup:["insertorderedlist","insertunorderedlist"],indentGroup:["outdent","indent"],linkGroup:["createlink","insertimage"]};
dojo.widget.html.Editor.formatBlockValues={"Normal":"p","Main heading":"h2","Sub heading":"h3","Sub sub headering":"h4","Preformatted":"pre"};
dojo.widget.html.Editor.fontNameValues={"Arial":"Arial, Helvetica, sans-serif","Verdana":"Verdana, sans-serif","Times New Roman":"Times New Roman, serif","Courier":"Courier New, monospace"};
dojo.widget.html.Editor.defaultItems=["commandGroup","|","linkGroup","|","textGroup","|","justifyGroup","|","listGroup","indentGroup","|","colorGroup"];
dojo.widget.html.Editor.supportedCommands=["save","cancel","|","-","/"," "];
dojo.lang.extend(dojo.widget.html.Editor,{widgetType:"Editor",items:dojo.widget.html.Editor.defaultItems,formatBlockItems:dojo.lang.shallowCopy(dojo.widget.html.Editor.formatBlockValues),fontNameItems:dojo.lang.shallowCopy(dojo.widget.html.Editor.fontNameValues),getItemProperties:function(_1){
var _2={};
switch(_1.toLowerCase()){
case "bold":
case "italic":
case "underline":
case "strikethrough":
_2.toggleItem=true;
break;
case "justifygroup":
_2.defaultButton="justifyleft";
_2.preventDeselect=true;
_2.buttonGroup=true;
break;
case "listgroup":
_2.buttonGroup=true;
break;
case "save":
case "cancel":
_2.label=dojo.string.capitalize(_1);
break;
case "forecolor":
case "hilitecolor":
_2.name=_1;
_2.toggleItem=true;
_2.icon=this.getCommandImage(_1);
break;
case "formatblock":
_2.name="formatBlock";
_2.values=this.formatBlockItems;
break;
case "fontname":
_2.name="fontName";
_2.values=this.fontNameItems;
}
return _2;
},validateItems:true,focusOnLoad:true,minHeight:"1em",_richText:null,_richTextType:"RichText",_toolbarContainer:null,_toolbarContainerType:"ToolbarContainer",_toolbars:[],_toolbarType:"Toolbar",_toolbarItemType:"ToolbarItem",buildRendering:function(_3,_4){
var _5=_4["dojo:"+this.widgetType.toLowerCase()]["nodeRef"];
var _6=dojo.widget.createWidget(this._richTextType,{focusOnLoad:this.focusOnLoad,minHeight:this.minHeight},_5);
var _7=this;
setTimeout(function(){
_7.setRichText(_6);
_7.initToolbar();
_7.fillInTemplate(_3,_4);
},0);
},setRichText:function(_8){
if(this._richText&&this._richText==_8){
dojo.debug("Already set the richText to this richText!");
return;
}
if(this._richText&&!this._richText.isClosed){
dojo.debug("You are switching richTexts yet you haven't closed the current one. Losing reference!");
}
this._richText=_8;
dojo.event.connect(this._richText,"close",this,"onClose");
dojo.event.connect(this._richText,"onLoad",this,"onLoad");
dojo.event.connect(this._richText,"onDisplayChanged",this,"updateToolbar");
if(this._toolbarContainer){
this._toolbarContainer.enable();
this.updateToolbar(true);
}
},initToolbar:function(){
if(this._toolbarContainer){
return;
}
this._toolbarContainer=dojo.widget.createWidget(this._toolbarContainerType);
var tb=this.addToolbar();
var _a=true;
for(var i=0;i<this.items.length;i++){
if(this.items[i]=="\n"){
tb=this.addToolbar();
}else{
if((this.items[i]=="|")&&(!_a)){
_a=true;
}else{
_a=this.addItem(this.items[i],tb);
}
}
}
this.insertToolbar(this._toolbarContainer.domNode,this._richText.domNode);
},insertToolbar:function(_c,_d){
dojo.html.insertBefore(_c,_d);
},addToolbar:function(_e){
this.initToolbar();
if(!(_e instanceof dojo.widget.html.Toolbar)){
_e=dojo.widget.createWidget(this._toolbarType);
}
this._toolbarContainer.addChild(_e);
this._toolbars.push(_e);
return _e;
},addItem:function(_f,tb,_11){
if(!tb){
tb=this._toolbars[0];
}
var cmd=((_f)&&(!dojo.lang.isUndefined(_f["getValue"])))?cmd=_f["getValue"]():_f;
var _13=dojo.widget.html.Editor.itemGroups;
if(_f instanceof dojo.widget.ToolbarItem){
tb.addChild(_f);
}else{
if(_13[cmd]){
var _14=_13[cmd];
var _15=true;
if(cmd=="justifyGroup"||cmd=="listGroup"){
var _16=[cmd];
for(var i=0;i<_14.length;i++){
if(_11||this.isSupportedCommand(_14[i])){
_16.push(this.getCommandImage(_14[i]));
}else{
_15=false;
}
}
if(_16.length){
var btn=tb.addChild(_16,null,this.getItemProperties(cmd));
dojo.event.connect(btn,"onClick",this,"_action");
dojo.event.connect(btn,"onChangeSelect",this,"_action");
}
return _15;
}else{
for(var i=0;i<_14.length;i++){
if(!this.addItem(_14[i],tb)){
_15=false;
}
}
return _15;
}
}else{
if((!_11)&&(!this.isSupportedCommand(cmd))){
return false;
}
if(_11||this.isSupportedCommand(cmd)){
cmd=cmd.toLowerCase();
if(cmd=="formatblock"){
var _19=dojo.widget.createWidget("ToolbarSelect",{name:"formatBlock",values:this.formatBlockItems});
tb.addChild(_19);
var _1a=this;
dojo.event.connect(_19,"onSetValue",function(_1b,_1c){
_1a.onAction("formatBlock",_1c);
});
}else{
if(cmd=="fontname"){
var _19=dojo.widget.createWidget("ToolbarSelect",{name:"fontName",values:this.fontNameItems});
tb.addChild(_19);
dojo.event.connect(_19,"onSetValue",dojo.lang.hitch(this,function(_1d,_1e){
this.onAction("fontName",_1e);
}));
}else{
if(dojo.lang.inArray(cmd,["forecolor","hilitecolor"])){
var btn=tb.addChild(dojo.widget.createWidget("ToolbarColorDialog",this.getItemProperties(cmd)));
dojo.event.connect(btn,"onSetValue",this,"_setValue");
}else{
var btn=tb.addChild(this.getCommandImage(cmd),null,this.getItemProperties(cmd));
if(dojo.lang.inArray(cmd,["save","cancel"])){
dojo.event.connect(btn,"onClick",this,"_close");
}else{
dojo.event.connect(btn,"onClick",this,"_action");
dojo.event.connect(btn,"onChangeSelect",this,"_action");
}
}
}
}
}
}
}
return true;
},enableToolbar:function(){
if(this._toolbarContainer){
this._toolbarContainer.domNode.style.display="";
this._toolbarContainer.enable();
}
},disableToolbar:function(_1f){
if(_1f){
if(this._toolbarContainer){
this._toolbarContainer.domNode.style.display="none";
}
}else{
if(this._toolbarContainer){
this._toolbarContainer.disable();
}
}
},_updateToolbarLastRan:null,_updateToolbarTimer:null,_updateToolbarFrequency:500,updateToolbar:function(_20){
if(!this._toolbarContainer){
return;
}
var _21=new Date()-this._updateToolbarLastRan;
if(!_20&&this._updateToolbarLastRan&&(_21<this._updateToolbarFrequency)){
clearTimeout(this._updateToolbarTimer);
var _22=this;
this._updateToolbarTimer=setTimeout(function(){
_22.updateToolbar();
},this._updateToolbarFrequency/2);
return;
}else{
this._updateToolbarLastRan=new Date();
}
var _23=this._toolbarContainer.getItems();
for(var i=0;i<_23.length;i++){
var _25=_23[i];
if(_25 instanceof dojo.widget.html.ToolbarSeparator){
continue;
}
var cmd=_25._name;
if(cmd=="save"||cmd=="cancel"){
continue;
}else{
if(cmd=="justifyGroup"){
try{
if(!this._richText.queryCommandEnabled("justifyleft")){
_25.disable(false,true);
}else{
_25.enable(false,true);
var _27=_25.getItems();
for(var j=0;j<_27.length;j++){
var _29=_27[j]._name;
var _2a=this._richText.queryCommandValue(_29);
if(typeof _2a=="boolean"&&_2a){
_2a=_29;
break;
}else{
if(typeof _2a=="string"){
_2a="justify"+_2a;
}else{
_2a=null;
}
}
}
if(!_2a){
_2a="justifyleft";
}
_25.setValue(_2a,false,true);
}
}
catch(err){
}
}else{
if(cmd=="listGroup"){
var _2b=_25.getItems();
for(var j=0;j<_2b.length;j++){
this.updateItem(_2b[j]);
}
}else{
this.updateItem(_25);
}
}
}
}
},updateItem:function(_2c){
try{
var cmd=_2c._name;
var _2e=this._richText.queryCommandEnabled(cmd);
_2c.setEnabled(_2e,false,true);
var _2f=this._richText.queryCommandState(cmd);
if(_2f&&cmd=="underline"){
_2f=!this._richText.queryCommandEnabled("unlink");
}
_2c.setSelected(_2f,false,true);
return true;
}
catch(err){
return false;
}
},supportedCommands:dojo.widget.html.Editor.supportedCommands.concat(),isSupportedCommand:function(cmd){
var yes=dojo.lang.inArray(cmd,this.supportedCommands);
if(!yes){
try{
var _32=this._richText||dojo.widget.html.RichText.prototype;
yes=_32.queryCommandAvailable(cmd);
}
catch(E){
}
}
return yes;
},getCommandImage:function(cmd){
if(cmd=="|"){
return cmd;
}else{
return dojo.uri.dojoUri("src/widget/templates/buttons/"+cmd+".gif");
}
},_action:function(e){
this._fire("onAction",e.getValue());
},_setValue:function(a,b){
this._fire("onAction",a.getValue(),b);
},_close:function(e){
if(!this._richText.isClosed){
this._richText.close(e.getName().toLowerCase()=="save");
}
},onAction:function(cmd,_39){
switch(cmd){
case "createlink":
if(!(_39=prompt("Please enter the URL of the link:","http://"))){
return;
}
break;
case "insertimage":
if(!(_39=prompt("Please enter the URL of the image:","http://"))){
return;
}
break;
}
this._richText.execCommand(cmd,_39);
},fillInTemplate:function(_3a,_3b){
},_fire:function(_3c){
if(dojo.lang.isFunction(this[_3c])){
var _3d=[];
if(arguments.length==1){
_3d.push(this);
}else{
for(var i=1;i<arguments.length;i++){
_3d.push(arguments[i]);
}
}
this[_3c].apply(this,_3d);
}
},getHtml:function(){
this._richText.contentFilters=this.contentFilters;
return this._richText.getEditorContent();
},getEditorContent:function(){
return this.getHtml();
},onClose:function(_3f,_40){
this.disableToolbar(_40);
if(_3f){
this._fire("onSave");
}else{
this._fire("onCancel");
}
},onLoad:function(){
},onSave:function(){
},onCancel:function(){
}});

