dojo.provide("dojo.widget.EditorTreeController");
dojo.require("dojo.event.*");
dojo.require("dojo.dnd.*");
dojo.require("dojo.dnd.TreeDragAndDrop");
dojo.require("dojo.fx.html");
dojo.require("dojo.json");
dojo.require("dojo.io.*");
dojo.require("dojo.widget.Container");
dojo.require("dojo.widget.Tree");
dojo.widget.tags.addParseTreeHandler("dojo:EditorTreeController");
dojo.widget.EditorTreeController=function(){
dojo.widget.HtmlWidget.call(this);
this.eventNames={select:"",collapse:"",expand:"",dblselect:"",swap:"",move:"",remove:""};
this.dragSources={};
this.dropTargets={};
};
dojo.inherits(dojo.widget.EditorTreeController,dojo.widget.HtmlWidget);
dojo.lang.extend(dojo.widget.EditorTreeController,{widgetType:"EditorTreeController",RPCUrl:"local",initialize:function(_1,_2){
if(_1["eventNaming"]=="default"||_1["eventnaming"]=="default"){
for(eventName in this.eventNames){
this.eventNames[eventName]=this.widgetId+"/"+eventName;
}
}
},enabledDND:true,subscribeTree:function(_3){
if(!_3.eventNames.nodeCreate){
dojo.raise("Can't subscribe controller to empty nodeCreate");
}
if(!_3.eventNames.treeClick){
dojo.raise("Can't subscribe controller to empty treeClick");
}
if(!_3.eventNames.iconClick){
dojo.raise("Can't subscribe controller to empty iconClick");
}
if(!_3.eventNames.titleClick){
dojo.raise("Can't subscribe controller to empty titleClick");
}
dojo.event.topic.subscribe(_3.eventNames.nodeCreate,this,"onNodeCreate");
dojo.event.topic.subscribe(_3.eventNames.treeClick,this,"onTreeClick");
dojo.event.topic.subscribe(_3.eventNames.iconClick,this,"onIconClick");
dojo.event.topic.subscribe(_3.eventNames.titleClick,this,"onTitleClick");
},canChangeParent:function(_4,_5){
var _6=_5;
while(_6.widgetType!=="EditorTree"){
if(_6===_4){
return false;
}
_6=_6.parentNode;
}
if(!_5.isFolder){
return false;
}
for(var i=0;i<_5.children.length;i++){
if(_5.children[i]==_4){
return false;
}
}
return true;
},getRPCUrl:function(_8){
if(this.RPCUrl=="local"){
var _9=document.location.href.substr(0,document.location.href.lastIndexOf("/"));
var _a=_9+"/"+_8;
return _a;
}
if(!this.RPCUrl){
dojo.raise("Empty RPCUrl: can't load");
}
return this.RPCUrl+(this.RPCUrl.indexOf("?")>-1?"&":"?")+"action="+_8;
},changeParentRemote:function(_b,_c){
_c.markLoading();
var _d={childId:_b.widgetId,childTreeId:_b.tree.widgetId,childOldParentId:_b.parentNode.widgetId,newParentId:_c.widgetId,newParentTreeId:_c.tree.widgetId};
var _e=dojo.io.argsFromMap(_d);
var _f=this.getRPCUrl("changeParent");
if(_e!=""){
_f+=(_f.indexOf("?")>-1?"&":"?")+_e;
}
var _10;
var _11;
try{
_10=dojo.hostenv.getText(_f);
_11=dj_eval("("+_10+")");
}
catch(e){
dojo.debug(e);
dojo.debug(_10);
dojo.raise("Failed to load node");
}
if(_11==true){
_b.tree.changeParent(_b,_c);
this.updateDND(_b);
return true;
}else{
if(dojo.lang.isObject(_11)){
dojo.raise(_11.error);
}else{
dojo.raise("Invalid response "+_10);
}
}
},changeParent:function(_12,_13){
if(!this.canChangeParent(_12,_13)){
return false;
}
if(_13.state==_13.loadStates.UNCHECKED){
this.loadRemote(_13,true);
}
var _14=_12.parentNode;
var _15=this.changeParentRemote(_12,_13);
if(!_15){
return _15;
}
dojo.event.topic.publish(this.eventNames.move,{oldParent:_14,newParent:_12.parentNode,child:_12});
this.expand(_13);
return _15;
},RPCErrorHandler:function(_16,obj){
dojo.raise("RPC error occured! Application restart/tree refresh recommended.");
},loadProcessResponse:function(_18,_19){
if(!dojo.lang.isArray(_19)){
dojo.raise("Not array loaded: "+_19);
}
for(var i=0;i<_19.length;i++){
var _1b=dojo.widget.createWidget(_18.widgetType,_19[i]);
_18.addChild(_1b);
}
_18.state=_18.loadStates.LOADED;
this.expand(_18);
},loadRemote:function(_1c,_1d){
_1c.markLoading();
var _1e={treeId:_1c.tree.widgetId,nodeId:_1c.widgetId};
var _1f=this.getRPCUrl("getChildren");
if(!_1d){
dojo.io.bind({url:_1f,load:dojo.lang.hitch(this,function(_20,obj){
this.loadProcessResponse(_1c,obj);
}),error:dojo.lang.hitch(this,this.RPCErrorHandler),mimetype:"text/json",preventCache:true,sync:_1d,content:_1e});
return;
}else{
var _22=dojo.io.argsFromMap(_1e);
if(_22!=""){
_1f+=(_1f.indexOf("?")>-1?"&":"?")+_22;
}
var _23;
try{
var _24=dojo.hostenv.getText(_1f);
_23=dj_eval("("+_24+")");
}
catch(e){
dojo.debug(e);
dojo.debug(_24);
dojo.raise("Failed to load node");
}
this.loadProcessResponse(_1c,_23);
}
},onTreeClick:function(_25){
var _26=_25.source;
if(_26.state==_26.loadStates.UNCHECKED){
this.loadRemote(_26);
}else{
if(_26.isExpanded){
this.collapse(_26);
}else{
this.expand(_26);
}
}
},onIconClick:function(_27){
this.onTitleClick(_27);
},onTitleClick:function(_28){
var _29=_28.source;
var e=_28.event;
if(_29.tree.selector.selectedNode===_29){
dojo.event.topic.publish(this.eventNames.dblselect,{source:_29});
return;
}
if(_29.tree.selector.selectedNode){
this.deselect(_29.tree.selector.selectedNode);
}
_29.tree.selector.selectedNode=_29;
this.select(_29);
},processDrop:function(_2b,_2c){
return this.changeParent(_2b,_2c);
},onNodeCreate:function(_2d){
this.registerDNDNode(_2d.source);
},select:function(_2e){
_2e.markSelected();
dojo.event.topic.publish(this.eventNames.select,{source:_2e});
},deselect:function(_2f){
_2f.unMarkSelected();
_2f.tree.selector.selectedNode=null;
},expand:function(_30){
if(_30.isExpanded){
return;
}
_30.expand();
dojo.event.topic.publish(this.eventNames.expand,{source:_30});
},collapse:function(_31){
if(!_31.isExpanded){
return;
}
_31.collapse();
dojo.event.topic.publish(this.eventNames.collapse,{source:_31});
},registerDNDNode:function(_32){
var _33=null;
var _34=null;
var _33=new dojo.dnd.TreeDragSource(_32.labelNode,this,_32.tree.widgetId,_32);
this.dragSources[_32.widgetId]=_33;
var _34=new dojo.dnd.TreeDropTarget(_32.labelNode,this,_32.tree.acceptDropSources,_32);
this.dropTargets[_32.widgetId]=_34;
if(!this.enabledDND){
if(_33){
dojo.dnd.dragManager.unregisterDragSource(_33);
}
if(_34){
dojo.dnd.dragManager.unregisterDropTarget(_34);
}
}
},unregisterDNDNode:function(_35){
if(this.dragSources[_35]){
dojo.dnd.dragManager.unregisterDragSource(this.dragSources[_35.widgetId]);
delete this.dragSources[_35.widgetId];
}
if(this.dropTargets[_35]){
dojo.dnd.dragManager.unregisterDropTarget(this.dropTargets[_35.widgetId]);
delete this.dropTargets[_35.widgetId];
}
},updateDND:function(_36){
this.unregisterDNDNode(_36);
this.registerDNDNode(_36);
for(var i=0;i<_36.children.length;i++){
this.updateDND(_36.children[i]);
}
},swapNodesRemote:function(_38,_39,_3a){
var _3b={treeId:this.widgetId,node1Id:_38.widgetId,node1Idx:_38.getParentIndex(),node2Id:_39.widgetId,node2Idx:_39.getParentIndex()};
dojo.io.bind({url:this.getRPCUrl("swapNodes"),load:dojo.lang.hitch(this,function(_3c,obj){
this.swapNodesProcessResponse(_38,_39,_3a,obj);
}),error:dojo.lang.hitch(this,this.RPCErrorHandler),mimetype:"text/json",preventCache:true,content:_3b});
},swapNodesProcessResponse:function(_3e,_3f,_40,_41){
if(_41==true){
this.doSwapNodes(_3e,_3f);
if(_40){
_40.apply(this,[_3e,_3f]);
}
return true;
}else{
if(dojo.lang.isObject(_41)){
dojo.raise(_41.error);
}else{
dojo.raise("Invalid response "+obj);
}
}
},doSwapNodes:function(_42,_43){
_42.tree.swapNodes(_42,_43);
dojo.event.topic.publish(this.eventNames.swap,{node1:_42,node2:_43});
},canSwapNodes:function(_44,_45){
return true;
},swapNodes:function(_46,_47,_48){
if(!this.canSwapNodes(_46,_47)){
return false;
}
return this.swapNodesRemote(_46,_47,_48);
},moveUp:function(_49,_4a){
var _4b=_49.getLeftSibling();
if(!_4b){
return false;
}
return this.swapNodes(_4b,_49,_4a);
},moveDown:function(_4c,_4d){
var _4e=_4c.getRightSibling();
if(!_4e){
return false;
}
return this.swapNodes(_4e,_4c,_4d);
},canRemoveNode:function(_4f){
return true;
},removeNode:function(_50,_51){
if(!this.canRemoveNode(_50)){
return false;
}
return this.removeNodeRemote(_50,_51);
},removeNodeRemote:function(_52,_53){
var _54={treeId:_52.tree.widgetId,nodeId:_52.widgetId};
dojo.io.bind({url:this.getRPCUrl("removeNode"),load:dojo.lang.hitch(this,function(_55,obj){
this.removeNodeProcessResponse(_52,_53,obj);
}),error:dojo.lang.hitch(this,this.RPCErrorHandler),mimetype:"text/json",preventCache:true,content:_54});
},removeNodeProcessResponse:function(_57,_58,_59){
if(_59==true){
this.doRemoveNode(_57,_57);
if(_58){
_58.apply(this,[_57]);
}
return true;
}else{
if(dojo.lang.isObject(_59)){
dojo.raise(_59.error);
}else{
dojo.raise("Invalid response "+obj);
}
}
},doRemoveNode:function(_5a){
if(_5a.tree.selector.selectedNode===_5a){
this.deselect(_5a);
}
this.unregisterDNDNode(_5a);
removed_node=_5a.tree.removeChild(_5a);
dojo.event.topic.publish(this.eventNames.remove,{node:removed_node});
},canCreateNode:function(_5b,_5c,_5d){
if(!_5b.isFolder){
return false;
}
return true;
},createNode:function(_5e,_5f,_60,_61){
if(!this.canCreateNode(_5e,_5f,_60)){
return false;
}
if(_5e.state==_5e.loadStates.UNCHECKED){
this.loadRemote(_5e,true);
}
return this.createNodeRemote(_5e,_5f,_60,_61);
},createNodeRemote:function(_62,_63,_64,_65){
var _66={treeId:_62.tree.widgetId,parentId:_62.widgetId,index:_63,data:dojo.json.serialize(_64)};
dojo.io.bind({url:this.getRPCUrl("createNode"),load:dojo.lang.hitch(this,function(_67,obj){
this.createNodeProcessResponse(_62,_63,_64,_65,obj);
}),error:dojo.lang.hitch(this,this.RPCErrorHandler),mimetype:"text/json",preventCache:true,content:_66});
},createNodeProcessResponse:function(_69,_6a,_6b,_6c,_6d){
if(_69.widgetType!="EditorTreeNode"){
dojo.raise("Can only add children to EditorTreeNode");
}
if(!dojo.lang.isObject(_6d)){
dojo.raise("Invalid response "+_6d);
}
if(!dojo.lang.isUndefined(_6d.error)){
dojo.raise(_6d.error);
}
this.doCreateNode(_69,_6a,_6d);
if(_6c){
_6c.apply(this,[_69,_6a,_6d]);
}
},doCreateNode:function(_6e,_6f,_70){
var _71=dojo.widget.createWidget("EditorTreeNode",_70);
_6e.addChild(_71,_6f);
this.expand(_6e);
}});

