dojo.provide("dojo.widget.Widget");
dojo.provide("dojo.widget.tags");
dojo.require("dojo.lang");
dojo.require("dojo.widget.Manager");
dojo.require("dojo.event.*");
dojo.require("dojo.string");
dojo.widget.Widget=function(){
this.children=[];
this.extraArgs={};
};
dojo.lang.extend(dojo.widget.Widget,{parent:null,isTopLevel:false,isModal:false,isEnabled:true,isHidden:false,isContainer:false,widgetId:"",widgetType:"Widget",toString:function(){
return "[Widget "+this.widgetType+", "+(this.widgetId||"NO ID")+"]";
},repr:function(){
return this.toString();
},enable:function(){
this.isEnabled=true;
},disable:function(){
this.isEnabled=false;
},hide:function(){
this.isHidden=true;
},show:function(){
this.isHidden=false;
},create:function(_1,_2,_3){
this.satisfyPropertySets(_1,_2,_3);
this.mixInProperties(_1,_2,_3);
this.postMixInProperties(_1,_2,_3);
dojo.widget.manager.add(this);
this.buildRendering(_1,_2,_3);
this.initialize(_1,_2,_3);
this.postInitialize(_1,_2,_3);
this.postCreate(_1,_2,_3);
return this;
},destroy:function(_4){
this.uninitialize();
this.destroyRendering(_4);
dojo.widget.manager.removeById(this.widgetId);
},destroyChildren:function(_5){
_5=(!_5)?function(){
return true;
}:_5;
for(var x=0;x<this.children.length;x++){
var tc=this.children[x];
if((tc)&&(_5(tc))){
tc.destroy();
}
}
},destroyChildrenOfType:function(_8){
_8=_8.toLowerCase();
this.destroyChildren(function(_9){
if(_9.widgetType.toLowerCase()==_8){
return true;
}else{
return false;
}
});
},getChildrenOfType:function(_a,_b){
var _c=[];
_a=_a.toLowerCase();
for(var x=0;x<this.children.length;x++){
if(this.children[x].widgetType.toLowerCase()==_a){
_c.push(this.children[x]);
}
if(_b){
_c=_c.concat(this.children[x].getChildrenOfType(_a,_b));
}
}
return _c;
},getDescendants:function(){
var _e=[];
var _f=[this];
var _10;
while(_10=_f.pop()){
_e.push(_10);
dojo.lang.forEach(_10.children,function(_11){
_f.push(_11);
});
}
return _e;
},satisfyPropertySets:function(_12){
return _12;
},mixInProperties:function(_13,_14){
if((_13["fastMixIn"])||(_14["fastMixIn"])){
for(var x in _13){
this[x]=_13[x];
}
return;
}
var _16;
var _17=dojo.widget.lcArgsCache[this.widgetType];
if(_17==null){
_17={};
for(var y in this){
_17[((new String(y)).toLowerCase())]=y;
}
dojo.widget.lcArgsCache[this.widgetType]=_17;
}
var _19={};
for(var x in _13){
if(!this[x]){
var y=_17[(new String(x)).toLowerCase()];
if(y){
_13[y]=_13[x];
x=y;
}
}
if(_19[x]){
continue;
}
_19[x]=true;
if((typeof this[x])!=(typeof _16)){
if(typeof _13[x]!="string"){
this[x]=_13[x];
}else{
if(dojo.lang.isString(this[x])){
this[x]=_13[x];
}else{
if(dojo.lang.isNumber(this[x])){
this[x]=new Number(_13[x]);
}else{
if(dojo.lang.isBoolean(this[x])){
this[x]=(_13[x].toLowerCase()=="false")?false:true;
}else{
if(dojo.lang.isFunction(this[x])){
var tn=dojo.lang.nameAnonFunc(new Function(_13[x]),this);
dojo.event.connect(this,x,this,tn);
}else{
if(dojo.lang.isArray(this[x])){
this[x]=_13[x].split(";");
}else{
if(this[x] instanceof Date){
this[x]=new Date(Number(_13[x]));
}else{
if(typeof this[x]=="object"){
var _1b=_13[x].split(";");
for(var y=0;y<_1b.length;y++){
var si=_1b[y].indexOf(":");
if((si!=-1)&&(_1b[y].length>si)){
this[x][dojo.string.trim(_1b[y].substr(0,si))]=_1b[y].substr(si+1);
}
}
}else{
this[x]=_13[x];
}
}
}
}
}
}
}
}
}else{
this.extraArgs[x]=_13[x];
}
}
},postMixInProperties:function(){
},initialize:function(_1d,_1e){
return false;
},postInitialize:function(_1f,_20){
return false;
},postCreate:function(_21,_22){
return false;
},uninitialize:function(){
return false;
},buildRendering:function(){
dj_unimplemented("dojo.widget.Widget.buildRendering, on "+this.toString()+", ");
return false;
},destroyRendering:function(){
dj_unimplemented("dojo.widget.Widget.destroyRendering");
return false;
},cleanUp:function(){
dj_unimplemented("dojo.widget.Widget.cleanUp");
return false;
},addedTo:function(_23){
},addChild:function(_24){
dj_unimplemented("dojo.widget.Widget.addChild");
return false;
},addChildAtIndex:function(_25,_26){
dj_unimplemented("dojo.widget.Widget.addChildAtIndex");
return false;
},removeChild:function(_27){
dj_unimplemented("dojo.widget.Widget.removeChild");
return false;
},removeChildAtIndex:function(_28){
dj_unimplemented("dojo.widget.Widget.removeChildAtIndex");
return false;
},resize:function(_29,_2a){
this.setWidth(_29);
this.setHeight(_2a);
},setWidth:function(_2b){
if((typeof _2b=="string")&&(_2b.substr(-1)=="%")){
this.setPercentageWidth(_2b);
}else{
this.setNativeWidth(_2b);
}
},setHeight:function(_2c){
if((typeof _2c=="string")&&(_2c.substr(-1)=="%")){
this.setPercentageHeight(_2c);
}else{
this.setNativeHeight(_2c);
}
},setPercentageHeight:function(_2d){
return false;
},setNativeHeight:function(_2e){
return false;
},setPercentageWidth:function(_2f){
return false;
},setNativeWidth:function(_30){
return false;
},getDescendants:function(){
var _31=[];
var _32=[this];
var _33;
while(_33=_32.pop()){
_31.push(_33);
dojo.lang.forEach(_33.children,function(_34){
_32.push(_34);
});
}
return _31;
}});
dojo.widget.lcArgsCache={};
dojo.widget.tags={};
dojo.widget.tags.addParseTreeHandler=function(_35){
var _36=_35.toLowerCase();
this[_36]=function(_37,_38,_39,_3a,_3b){
return dojo.widget.buildWidgetFromParseTree(_36,_37,_38,_39,_3a,_3b);
};
};
dojo.widget.tags.addParseTreeHandler("dojo:widget");
dojo.widget.tags["dojo:propertyset"]=function(_3c,_3d,_3e){
var _3f=_3d.parseProperties(_3c["dojo:propertyset"]);
};
dojo.widget.tags["dojo:connect"]=function(_40,_41,_42){
var _43=_41.parseProperties(_40["dojo:connect"]);
};
dojo.widget.buildWidgetFromParseTree=function(_44,_45,_46,_47,_48,_49){
var _4a=_44.split(":");
_4a=(_4a.length==2)?_4a[1]:_44;
var _4b=_49||_46.parseProperties(_45["dojo:"+_4a]);
var _4c=dojo.widget.manager.getImplementation(_4a);
if(!_4c){
throw new Error("cannot find \""+_4a+"\" widget");
}else{
if(!_4c.create){
throw new Error("\""+_4a+"\" widget object does not appear to implement *Widget");
}
}
_4b["dojoinsertionindex"]=_48;
var ret=_4c.create(_4b,_45,_47);
return ret;
};

