dojo.provide("dojo.string");
dojo.require("dojo.lang");
dojo.string.trim=function(_1,wh){
if(!dojo.lang.isString(_1)){
return _1;
}
if(!_1.length){
return _1;
}
if(wh>0){
return _1.replace(/^\s+/,"");
}else{
if(wh<0){
return _1.replace(/\s+$/,"");
}else{
return _1.replace(/^\s+|\s+$/g,"");
}
}
};
dojo.string.trimStart=function(_3){
return dojo.string.trim(_3,1);
};
dojo.string.trimEnd=function(_4){
return dojo.string.trim(_4,-1);
};
dojo.string.paramString=function(_5,_6,_7){
for(var _8 in _6){
var re=new RegExp("\\%\\{"+_8+"\\}","g");
_5=_5.replace(re,_6[_8]);
}
if(_7){
_5=_5.replace(/%\{([^\}\s]+)\}/g,"");
}
return _5;
};
dojo.string.capitalize=function(_a){
if(!dojo.lang.isString(_a)){
return "";
}
if(arguments.length==0){
_a=this;
}
var _b=_a.split(" ");
var _c="";
var _d=_b.length;
for(var i=0;i<_d;i++){
var _f=_b[i];
_f=_f.charAt(0).toUpperCase()+_f.substring(1,_f.length);
_c+=_f;
if(i<_d-1){
_c+=" ";
}
}
return new String(_c);
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _13=escape(str);
var _14,re=/%u([0-9A-F]{4})/i;
while((_14=_13.match(re))){
var num=Number("0x"+_14[1]);
var _16=escape("&#"+num+";");
ret+=_13.substring(0,_14.index)+_16;
_13=_13.substring(_14.index+_14[0].length);
}
ret+=_13.replace(/\+/g,"%2B");
return ret;
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}else{
return str.substring(0,len).replace(/\.+$/,"")+"...";
}
};
dojo.string.escape=function(_19,str){
var _1b=[];
for(var i=1;i<arguments.length;i++){
_1b.push(arguments[i]);
}
switch(_19.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,_1b);
case "sql":
return dojo.string.escapeSql.apply(this,_1b);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,_1b);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,_1b);
case "ascii":
return dojo.string.encodeAscii.apply(this,_1b);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_1e){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_1e){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.repeat=function(str,_23,_24){
var out="";
for(var i=0;i<_23;i++){
out+=str;
if(_24&&i<_23-1){
out+=_24;
}
}
return out;
};
dojo.string.endsWith=function(str,end,_29){
if(_29){
str=str.toLowerCase();
end=end.toLowerCase();
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_2d,_2e){
if(_2e){
str=str.toLowerCase();
_2d=_2d.toLowerCase();
}
return str.indexOf(_2d)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i]>-1)){
return true;
}
}
return false;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.string.normalizeNewlines=function(_3e,_3f){
if(_3f=="\n"){
_3e=_3e.replace(/\r\n/g,"\n");
_3e=_3e.replace(/\r/g,"\n");
}else{
if(_3f=="\r"){
_3e=_3e.replace(/\r\n/g,"\r");
_3e=_3e.replace(/\n/g,"\r");
}else{
_3e=_3e.replace(/([^\r])\n/g,"$1\r\n");
_3e=_3e.replace(/\r([^\n])/g,"\r\n$1");
}
}
return _3e;
};
dojo.string.splitEscaped=function(str,_41){
var _42=[];
for(var i=0,prevcomma=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_41){
_42.push(str.substring(prevcomma,i));
prevcomma=i+1;
}
}
_42.push(str.substr(prevcomma));
return _42;
};
dojo.string.addToPrototype=function(){
for(var _44 in dojo.string){
if(dojo.lang.isFunction(dojo.string[_44])){
var _45=(function(){
var _46=_44;
switch(_46){
case "addToPrototype":
return null;
break;
case "escape":
return function(_47){
return dojo.string.escape(_47,this);
};
break;
default:
return function(){
var _48=[this];
for(var i=0;i<arguments.length;i++){
_48.push(arguments[i]);
}
dojo.debug(_48);
return dojo.string[_46].apply(dojo.string,_48);
};
}
})();
if(_45){
String.prototype[_44]=_45;
}
}
}
};

